package dm8xx.examples;

public class Bin<E>
{
	private E element;


	public static void main(String[] args)
	{
		Bin<String> bin1 = new Bin<String>();
		bin1.put("some text");
		String str1 = bin1.get();

		Bin<String> bin2 = Bin.create();
		bin2.put("some text");
		String str2 = bin2.get();

		Bin<String> bin3 = Bin.<String>create();
		bin3.put("some text");
		String str3 = bin3.get();
	}


	public E get()
	{
		return element;
	}


	public void put(E element)
	{
		this.element = element;
	}


	public static <D> Bin<D> create()
	{
		return new Bin<D>();
	}


	public void put1(Bin bin)
	{
		//put(bin.get());
	}


	public void put2(Bin<Object> bin)
	{
		//put(bin.get());
	}


	public void put3(Bin<E> bin)
	{
		put(bin.get());
	}


	public void put4(Bin<? extends E> bin)
	{
		put(bin.get());
	}


	public static <F> void copy1(Bin<F> src, Bin<F> dst)
	{
		dst.put(src.get());
	}


	public static <G> void copy2(Bin<? extends G> src, Bin<? super G> dst)
	{
		dst.put(src.get());
	}
}
