package dm8xx.benchmark;

public abstract class AbstractBenchmark
{
	protected AbstractBenchmark() {}


	protected static void printResult(String task, int N, String result)
	{
		System.out.println("*** " + task + ", N = " + N);
		System.out.println(result);
	}


	protected static void printAllResults(String[] tasks, int[] N,
			String[][] results)
	{
		System.out.println("---");
		
		for(int i = 0; i < tasks.length; i++) {
			for(int j = 0; j < N.length; j++) {
				printResult(tasks[i], N[j], results[i][j]);
			}
		}
	}
}
